function love.load()
  love.window.setMode( 256, 240)
  love.window.setFullscreen(true, "exclusive")
  karts = love.graphics.newImage("karts.png")
  --tracks
  monaco = love.graphics.newImage("easytrack.png")
  monacocol = love.image.newImageData("easytrackcolisionmap.png")
  --kart quads
  machs = love.graphics.newQuad(0,0,15,10,64,64)
  funkm = love.graphics.newQuad(0,10,15,10,64,64)
  redbl = love.graphics.newQuad(0,20,15,10,64,64)
  fcina = love.graphics.newQuad(0,30,15,10,64,64)
  ferri = love.graphics.newQuad(0,40,15,10,64,64)
  oilex = love.graphics.newQuad(0,50,15,10,64,64)
  -- top speeds
  fmtop = 83
  mctop = 83
  rbtop = 84
  fitop = 82
  ferri = 85
  oilex = 82
  --extra vars
  playrot = 0
  speed = 0
  hndlin = .03
  px = -100
  py = -100
  enginebrake = true
  rot = 0
  
end

function collisiondetection()
  ix = px + 120
  iy = py + 128
  ra, ga, ba, aa = monacocol:getPixel(iy,ix)
  --rb, gb, bb, ab = monacocol:getPixel(iy-10,ix)
  --rc, gc, bc, ac = monacocol:getPixel(iy,ix+15)
  --rd, gd, bd, ad = monacocol:getPixel(iy-10,ix15)
  if ga == 255 then
    fmtop = 83
  end
  if ra == 255 then
    fmtop= 10
    speed = 10
  end
  if ba == 255 then
    speed = 0
  end
end

function love.keypressed( key )
  if key == "escape" then
    love.event.quit()
  end
end

function love.keyreleased(key)
  if key == "up" then
    enginebrake = true
  end
  if key == "left" or key == "right" then
    rot = 0
  end
end
  
function love.update(dt)
  --keyboard commands, duh
  if love.keyboard.isDown( "up" ) then
    if speed < fmtop then
      speed = speed + .4
      enginebrake = false
    end
  end
  if love.keyboard.isDown("down") then
    speed = speed - .7
  end
  if love.keyboard.isDown("left") and speed ~= 0 then
    playrot = playrot - hndlin
    if speed > .1 then
      speed = speed - .1
    end
  end
  if love.keyboard.isDown("right") and speed ~= 0 then
    playrot = playrot + hndlin
    if speed > .1 then
      speed = speed - .1
    end
  end
  if enginebrake == true and speed > 0 then
    speed = speed - .1
    if speed < -.2 and speed < .2 then
      speed = 0
    end
  end
  --math type junk
  pdis = speed/16
  plsx = (pdis * math.sin(playrot))
  plsy = (pdis * math.cos(playrot))
  px = plsx + px
  py = plsy + py
  --colision detection running
  collisiondetection()
end

function love.draw()
  --mapdraw
  love.graphics.draw(monaco, -py,-px, 0,1,1)
  --kart draw
  love.graphics.draw(karts, funkm, 128, 120, playrot)
  --sped draw
  love.graphics.rectangle("fill",220,200,20,20)
  love.graphics.print(speed, 220, 220)
  --love.graphics.draw(karts, machs, 5, 15)
  --love.graphics.draw(karts, redbl, 5, 25)
  --love.graphics.draw(karts, fcina, 5, 35)
  --love.graphics.draw(karts, ferri, 5, 45)
  --love.graphics.draw(karts, oilex, 5, 55)
end